import Newable from './Newable';
import TypeConf from './TypeConf';
import { Store } from './util';
export default abstract class TypeConfBase implements TypeConf {
    private readonly override;
    private readonly stores;
    private rootAccessor;
    constructor();
    private resolve<T>(name, resolve?);
    private exists(name);
    protected addStore(store: Store, name: string): void;
    withStore(storage: {
        [key: string]: any;
    }, name?: string): TypeConf;
    withSupplier(supplier: (key: string) => any, name?: string): TypeConf;
    withArgv(_?: (args: string[]) => {
        [key: string]: any;
    }): TypeConf;
    withEnv(_?: string, __?: string): TypeConf;
    withFile(_: string): TypeConf;
    withDOMNode(_: string): TypeConf;
    set(key: string, value: any): TypeConf;
    unset(key: string): TypeConf;
    get<T>(name: string, transform: (x: any) => T): T;
    get<T>(name: string, transform?: undefined): any;
    getString(name: string, fallback: string): string;
    getString(name: string, fallback?: string): string | undefined;
    getNumber(name: string, fallback: number): number;
    getNumber(name: string, fallback?: number): number | undefined;
    getBoolean(name: string): boolean;
    getObject(name: string, fallback: object): object;
    getObject(name: string, fallback?: object): object | undefined;
    getType<T>(name: string, newable: Newable<T>, fallback: T): T;
    getType<T>(name: string, newable: Newable<T>, fallback?: T): T | undefined;
    toJSON(): object;
    toBase64(): string;
}
