"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const StoreError_1 = require("./StoreError");
const TypeConfBase_1 = require("./TypeConfBase");
const util_1 = require("./util");
class TypeConfBrowser extends TypeConfBase_1.default {
    withDOMNode(id, attribute = 'content') {
        const element = document.getElementById(id);
        if (!element || !element.hasAttribute(attribute)) {
            return this;
        }
        const encodedString = element.getAttribute(attribute);
        if (!encodedString) {
            return this;
        }
        let storage;
        try {
            storage = JSON.parse(atob(encodedString));
        }
        catch (e) {
            throw new StoreError_1.default(`cannot read attribute ${attribute} of DOM node ${id}`, e);
        }
        const store = util_1.createStore(new util_1.ObjectSupplier(storage));
        this.addStore(store, `__DOM_${id}__`);
        return this;
    }
    toBase64() {
        return btoa(JSON.stringify(this.toJSON()));
    }
}
exports.default = TypeConfBrowser;
//# sourceMappingURL=TypeConfBrowser.js.map