import Newable from './Newable';
/**
 * Resolve a raw value into a string.
 *
 * @param value Raw value.
 * @returns String or undefined if value is undefined.
 */
export declare function resolveString(value: any): string | undefined;
/**
 * Resolve a raw value into a number.
 *
 * @param value Raw value.
 * @returns Number or undefined if value is undefined.
 * @throws TypeError if the value is defined but cannot be parsed as a number.
 */
export declare function resolveNumber(value: any): number | undefined;
/**
 * Resolve a raw value into an object.
 *
 * @param value Raw value.
 * @returns Object or undefined if value is undefined.
 * @throws TypeError if the value is defined but cannot be parsed as an object.
 */
export declare function resolveObject(value: any): object | undefined;
/**
 * Create a resolver for an instantiable type.
 *
 * @param newable Constructor of the type to instantiate.
 * @returns Resolver for type Newable<T>.
 */
export declare function resolveType<T>(newable: Newable<T>): (value: any) => T | undefined;
